using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.SessionState;

namespace CFEventFolder.Helpers
{
    public class SessionHelper
    {
        public const string SessionCurrentUserSessionCheck = "VariableName";

        /// <summary>
        /// Сохранение пользователя в сессию для проверки
        /// </summary>
        public static void SaveToSession(HttpSessionStateBase Session, string username)
        {
            Session.Add(SessionCurrentUserSessionCheck, username);
        }

        /// <summary>
        /// Получение списка всех активных сессий
        /// Возвращается список сессий только для заданного приложения???
        /// http://stackoverflow.com/questions/1470334/list-all-active-asp-net-sessions
        /// </summary>
        public static List<SessionStateItemCollection> GetActiveSessions()
        {
            List<SessionStateItemCollection> Result = new List<SessionStateItemCollection>();

            object obj = typeof(HttpRuntime).GetProperty("CacheInternal", BindingFlags.NonPublic | BindingFlags.Static).GetValue(null, null);
            object[] obj2 = (object[])obj.GetType().GetField("_caches", BindingFlags.NonPublic | BindingFlags.Instance).GetValue(obj);

            for (int i = 0; i < obj2.Length; i++)
            {
                Hashtable c2 = (Hashtable)obj2[i].GetType().GetField("_entries", BindingFlags.NonPublic | BindingFlags.Instance).GetValue(obj2[i]);
                foreach (DictionaryEntry entry in c2)
                {
                    object o1 = entry.Value.GetType().GetProperty("Value", BindingFlags.NonPublic | BindingFlags.Instance).GetValue(entry.Value, null);
                    if (o1.GetType().ToString() == "System.Web.SessionState.InProcSessionState")
                    {
                        SessionStateItemCollection sess = (SessionStateItemCollection)o1.GetType().GetField("_sessionItems", BindingFlags.NonPublic | BindingFlags.Instance).GetValue(o1);
                        if (sess != null)
                        {
                            Result.Add(sess);
                        }
                    }
                }
            }

            return Result;
        }

        /// <summary>
        /// Проверка что пользователь с таким именем уже есть в активных сессиях
        /// </summary>
        public static bool isUserInActiveSessions(string username)
        {
            bool Result = false;

            //Список всех активных сессий
            List<SessionStateItemCollection> sessions = GetActiveSessions();

            foreach(var x in sessions)
            {
                //Поиск сессионной переменной с заданным именем
                object obj = x[SessionCurrentUserSessionCheck];
                if(obj != null)
                {
                    //Если переменная найдена
                    string sessionUsername = (string)obj;
                    if(sessionUsername == username)
                    {
                        Result = true;
                        break;
                    }
                }
            }

            return Result;
        }

    }
}